
/* 
 * agt_time_filter.c
 *
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *

*** Originally generated by yangdump 2.0.1297

    module yuma-time-filter
    revision 2012-11-15

    namespace http://netconfcentral.org/ns/yuma-time-filter
    organization Netconf Central

 */

#include <libxml/xmlstring.h>

#include "procdefs.h"
#include "agt.h"
#include "agt_cb.h"
#include "agt_timer.h"
#include "agt_util.h"
#include "dlq.h"
#include "ncx.h"
#include "ncxmod.h"
#include "ncxtypes.h"
#include "status.h"
#include "agt_time_filter.h"


/* module static variables */
static ncx_module_t *yuma_time_filter_mod;

/* put your static variables here */


/********************************************************************
* FUNCTION y_yuma_time_filter_init_static_vars
* 
* initialize module static variables
* 
********************************************************************/
static void
    y_yuma_time_filter_init_static_vars (void)
{
    yuma_time_filter_mod = NULL;

    /* init your static variables here */

} /* y_yuma_time_filter_init_static_vars */


/********************************************************************
* FUNCTION y_yuma_time_filter_init
* 
* initialize the yuma-time-filter server instrumentation library
* 
* INPUTS:
*    modname == requested module name
*    revision == requested version (NULL for any)
* 
* RETURNS:
*     error status
********************************************************************/
status_t
    y_yuma_time_filter_init (
        const xmlChar *modname,
        const xmlChar *revision)
{
    agt_profile_t *agt_profile;
    status_t res;

    y_yuma_time_filter_init_static_vars();

    /* change if custom handling done */
    if (xml_strcmp(modname, y_yuma_time_filter_M_yuma_time_filter)) {
        return ERR_NCX_UNKNOWN_MODULE;
    }

    if (revision && 
        xml_strcmp(revision, y_yuma_time_filter_R_yuma_time_filter)) {
        return ERR_NCX_WRONG_VERSION;
    }

    agt_profile = agt_get_profile();

    res = ncxmod_load_module(
        y_yuma_time_filter_M_yuma_time_filter,
        y_yuma_time_filter_R_yuma_time_filter,
        &agt_profile->agt_savedevQ,
        &yuma_time_filter_mod);
    if (res != NO_ERR) {
        return res;
    }
    
    /* put your module initialization code here */
    
    return res;
} /* y_yuma_time_filter_init */


/********************************************************************
* FUNCTION y_yuma_time_filter_init2
* 
* SIL init phase 2: non-config data structures
* Called after running config is loaded
* 
* RETURNS:
*     error status
********************************************************************/
status_t
    y_yuma_time_filter_init2 (void)
{
    status_t res;

    res = NO_ERR;
    /* put your init2 code here */
    
    return res;
} /* y_yuma_time_filter_init2 */


/********************************************************************
* FUNCTION y_yuma_time_filter_cleanup
*    cleanup the server instrumentation library
* 
********************************************************************/
void
    y_yuma_time_filter_cleanup (void)
{
    /* put your cleanup code here */
    
} /* y_yuma_time_filter_cleanup */

/* END yuma_time_filter.c */
